/**
 * ORY Hydra - Cloud Native OAuth 2.0 and OpenID Connect Server
 * Welcome to the ORY Hydra HTTP API documentation. You will find documentation for all HTTP APIs here. Keep in mind that this document reflects the latest branch, always. Support for versioned documentation is coming in the future.
 *
 * OpenAPI spec version: Latest
 * Contact: hi@ory.am
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

;(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define([
      'ApiClient',
      'model/ExtKeyUsage',
      'model/Extension',
      'model/IP',
      'model/IPNet',
      'model/KeyUsage',
      'model/ModelInt',
      'model/Name',
      'model/ObjectIdentifier',
      'model/PublicKeyAlgorithm',
      'model/SignatureAlgorithm',
      'model/URL'
    ], factory)
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(
      require('../ApiClient'),
      require('./ExtKeyUsage'),
      require('./Extension'),
      require('./IP'),
      require('./IPNet'),
      require('./KeyUsage'),
      require('./ModelInt'),
      require('./Name'),
      require('./ObjectIdentifier'),
      require('./PublicKeyAlgorithm'),
      require('./SignatureAlgorithm'),
      require('./URL')
    )
  } else {
    // Browser globals (root is window)
    if (!root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer) {
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer = {}
    }
    root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.Certificate = factory(
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.ApiClient,
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.ExtKeyUsage,
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.Extension,
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.IP,
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.IPNet,
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.KeyUsage,
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.ModelInt,
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.Name,
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.ObjectIdentifier,
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.PublicKeyAlgorithm,
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.SignatureAlgorithm,
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.URL
    )
  }
})(this, function(
  ApiClient,
  ExtKeyUsage,
  Extension,
  IP,
  IPNet,
  KeyUsage,
  ModelInt,
  Name,
  ObjectIdentifier,
  PublicKeyAlgorithm,
  SignatureAlgorithm,
  URL
) {
  'use strict'

  /**
   * The Certificate model module.
   * @module model/Certificate
   * @version Latest
   */

  /**
   * Constructs a new <code>Certificate</code>.
   * @alias module:model/Certificate
   * @class
   */
  var exports = function() {
    var _this = this
  }

  /**
   * Constructs a <code>Certificate</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Certificate} obj Optional instance to populate.
   * @return {module:model/Certificate} The populated <code>Certificate</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports()

      if (data.hasOwnProperty('AuthorityKeyId')) {
        obj['AuthorityKeyId'] = ApiClient.convertToType(
          data['AuthorityKeyId'],
          ['Number']
        )
      }
      if (data.hasOwnProperty('BasicConstraintsValid')) {
        obj['BasicConstraintsValid'] = ApiClient.convertToType(
          data['BasicConstraintsValid'],
          'Boolean'
        )
      }
      if (data.hasOwnProperty('CRLDistributionPoints')) {
        obj['CRLDistributionPoints'] = ApiClient.convertToType(
          data['CRLDistributionPoints'],
          ['String']
        )
      }
      if (data.hasOwnProperty('DNSNames')) {
        obj['DNSNames'] = ApiClient.convertToType(data['DNSNames'], ['String'])
      }
      if (data.hasOwnProperty('EmailAddresses')) {
        obj['EmailAddresses'] = ApiClient.convertToType(
          data['EmailAddresses'],
          ['String']
        )
      }
      if (data.hasOwnProperty('ExcludedDNSDomains')) {
        obj['ExcludedDNSDomains'] = ApiClient.convertToType(
          data['ExcludedDNSDomains'],
          ['String']
        )
      }
      if (data.hasOwnProperty('ExcludedEmailAddresses')) {
        obj['ExcludedEmailAddresses'] = ApiClient.convertToType(
          data['ExcludedEmailAddresses'],
          ['String']
        )
      }
      if (data.hasOwnProperty('ExcludedIPRanges')) {
        obj['ExcludedIPRanges'] = ApiClient.convertToType(
          data['ExcludedIPRanges'],
          [IPNet]
        )
      }
      if (data.hasOwnProperty('ExcludedURIDomains')) {
        obj['ExcludedURIDomains'] = ApiClient.convertToType(
          data['ExcludedURIDomains'],
          ['String']
        )
      }
      if (data.hasOwnProperty('ExtKeyUsage')) {
        obj['ExtKeyUsage'] = ApiClient.convertToType(data['ExtKeyUsage'], [
          ExtKeyUsage
        ])
      }
      if (data.hasOwnProperty('Extensions')) {
        obj['Extensions'] = ApiClient.convertToType(data['Extensions'], [
          Extension
        ])
      }
      if (data.hasOwnProperty('ExtraExtensions')) {
        obj['ExtraExtensions'] = ApiClient.convertToType(
          data['ExtraExtensions'],
          [Extension]
        )
      }
      if (data.hasOwnProperty('IPAddresses')) {
        obj['IPAddresses'] = ApiClient.convertToType(data['IPAddresses'], [IP])
      }
      if (data.hasOwnProperty('IsCA')) {
        obj['IsCA'] = ApiClient.convertToType(data['IsCA'], 'Boolean')
      }
      if (data.hasOwnProperty('Issuer')) {
        obj['Issuer'] = Name.constructFromObject(data['Issuer'])
      }
      if (data.hasOwnProperty('IssuingCertificateURL')) {
        obj['IssuingCertificateURL'] = ApiClient.convertToType(
          data['IssuingCertificateURL'],
          ['String']
        )
      }
      if (data.hasOwnProperty('KeyUsage')) {
        obj['KeyUsage'] = KeyUsage.constructFromObject(data['KeyUsage'])
      }
      if (data.hasOwnProperty('MaxPathLen')) {
        obj['MaxPathLen'] = ApiClient.convertToType(
          data['MaxPathLen'],
          'Number'
        )
      }
      if (data.hasOwnProperty('MaxPathLenZero')) {
        obj['MaxPathLenZero'] = ApiClient.convertToType(
          data['MaxPathLenZero'],
          'Boolean'
        )
      }
      if (data.hasOwnProperty('NotBefore')) {
        obj['NotBefore'] = ApiClient.convertToType(data['NotBefore'], 'Date')
      }
      if (data.hasOwnProperty('OCSPServer')) {
        obj['OCSPServer'] = ApiClient.convertToType(data['OCSPServer'], [
          'String'
        ])
      }
      if (data.hasOwnProperty('PermittedDNSDomains')) {
        obj['PermittedDNSDomains'] = ApiClient.convertToType(
          data['PermittedDNSDomains'],
          ['String']
        )
      }
      if (data.hasOwnProperty('PermittedDNSDomainsCritical')) {
        obj['PermittedDNSDomainsCritical'] = ApiClient.convertToType(
          data['PermittedDNSDomainsCritical'],
          'Boolean'
        )
      }
      if (data.hasOwnProperty('PermittedEmailAddresses')) {
        obj['PermittedEmailAddresses'] = ApiClient.convertToType(
          data['PermittedEmailAddresses'],
          ['String']
        )
      }
      if (data.hasOwnProperty('PermittedIPRanges')) {
        obj['PermittedIPRanges'] = ApiClient.convertToType(
          data['PermittedIPRanges'],
          [IPNet]
        )
      }
      if (data.hasOwnProperty('PermittedURIDomains')) {
        obj['PermittedURIDomains'] = ApiClient.convertToType(
          data['PermittedURIDomains'],
          ['String']
        )
      }
      if (data.hasOwnProperty('PolicyIdentifiers')) {
        obj['PolicyIdentifiers'] = ApiClient.convertToType(
          data['PolicyIdentifiers'],
          [ObjectIdentifier]
        )
      }
      if (data.hasOwnProperty('PublicKey')) {
        obj['PublicKey'] = ApiClient.convertToType(data['PublicKey'], Object)
      }
      if (data.hasOwnProperty('PublicKeyAlgorithm')) {
        obj['PublicKeyAlgorithm'] = PublicKeyAlgorithm.constructFromObject(
          data['PublicKeyAlgorithm']
        )
      }
      if (data.hasOwnProperty('Raw')) {
        obj['Raw'] = ApiClient.convertToType(data['Raw'], ['Number'])
      }
      if (data.hasOwnProperty('RawIssuer')) {
        obj['RawIssuer'] = ApiClient.convertToType(data['RawIssuer'], [
          'Number'
        ])
      }
      if (data.hasOwnProperty('RawSubject')) {
        obj['RawSubject'] = ApiClient.convertToType(data['RawSubject'], [
          'Number'
        ])
      }
      if (data.hasOwnProperty('RawSubjectPublicKeyInfo')) {
        obj['RawSubjectPublicKeyInfo'] = ApiClient.convertToType(
          data['RawSubjectPublicKeyInfo'],
          ['Number']
        )
      }
      if (data.hasOwnProperty('RawTBSCertificate')) {
        obj['RawTBSCertificate'] = ApiClient.convertToType(
          data['RawTBSCertificate'],
          ['Number']
        )
      }
      if (data.hasOwnProperty('SerialNumber')) {
        obj['SerialNumber'] = ModelInt.constructFromObject(data['SerialNumber'])
      }
      if (data.hasOwnProperty('Signature')) {
        obj['Signature'] = ApiClient.convertToType(data['Signature'], [
          'Number'
        ])
      }
      if (data.hasOwnProperty('SignatureAlgorithm')) {
        obj['SignatureAlgorithm'] = SignatureAlgorithm.constructFromObject(
          data['SignatureAlgorithm']
        )
      }
      if (data.hasOwnProperty('Subject')) {
        obj['Subject'] = Name.constructFromObject(data['Subject'])
      }
      if (data.hasOwnProperty('SubjectKeyId')) {
        obj['SubjectKeyId'] = ApiClient.convertToType(data['SubjectKeyId'], [
          'Number'
        ])
      }
      if (data.hasOwnProperty('URIs')) {
        obj['URIs'] = ApiClient.convertToType(data['URIs'], [URL])
      }
      if (data.hasOwnProperty('UnhandledCriticalExtensions')) {
        obj['UnhandledCriticalExtensions'] = ApiClient.convertToType(
          data['UnhandledCriticalExtensions'],
          [ObjectIdentifier]
        )
      }
      if (data.hasOwnProperty('UnknownExtKeyUsage')) {
        obj['UnknownExtKeyUsage'] = ApiClient.convertToType(
          data['UnknownExtKeyUsage'],
          [ObjectIdentifier]
        )
      }
      if (data.hasOwnProperty('Version')) {
        obj['Version'] = ApiClient.convertToType(data['Version'], 'Number')
      }
    }
    return obj
  }

  /**
   * @member {Array.<Number>} AuthorityKeyId
   */
  exports.prototype['AuthorityKeyId'] = undefined
  /**
   * BasicConstraintsValid indicates whether IsCA, MaxPathLen, and MaxPathLenZero are valid.
   * @member {Boolean} BasicConstraintsValid
   */
  exports.prototype['BasicConstraintsValid'] = undefined
  /**
   * CRL Distribution Points
   * @member {Array.<String>} CRLDistributionPoints
   */
  exports.prototype['CRLDistributionPoints'] = undefined
  /**
   * Subject Alternate Name values. (Note that these values may not be valid if invalid values were contained within a parsed certificate. For example, an element of DNSNames may not be a valid DNS domain name.)
   * @member {Array.<String>} DNSNames
   */
  exports.prototype['DNSNames'] = undefined
  /**
   * @member {Array.<String>} EmailAddresses
   */
  exports.prototype['EmailAddresses'] = undefined
  /**
   * @member {Array.<String>} ExcludedDNSDomains
   */
  exports.prototype['ExcludedDNSDomains'] = undefined
  /**
   * @member {Array.<String>} ExcludedEmailAddresses
   */
  exports.prototype['ExcludedEmailAddresses'] = undefined
  /**
   * @member {Array.<module:model/IPNet>} ExcludedIPRanges
   */
  exports.prototype['ExcludedIPRanges'] = undefined
  /**
   * @member {Array.<String>} ExcludedURIDomains
   */
  exports.prototype['ExcludedURIDomains'] = undefined
  /**
   * @member {Array.<module:model/ExtKeyUsage>} ExtKeyUsage
   */
  exports.prototype['ExtKeyUsage'] = undefined
  /**
   * Extensions contains raw X.509 extensions. When parsing certificates, this can be used to extract non-critical extensions that are not parsed by this package. When marshaling certificates, the Extensions field is ignored, see ExtraExtensions.
   * @member {Array.<module:model/Extension>} Extensions
   */
  exports.prototype['Extensions'] = undefined
  /**
   * ExtraExtensions contains extensions to be copied, raw, into any marshaled certificates. Values override any extensions that would otherwise be produced based on the other fields. The ExtraExtensions field is not populated when parsing certificates, see Extensions.
   * @member {Array.<module:model/Extension>} ExtraExtensions
   */
  exports.prototype['ExtraExtensions'] = undefined
  /**
   * @member {Array.<module:model/IP>} IPAddresses
   */
  exports.prototype['IPAddresses'] = undefined
  /**
   * @member {Boolean} IsCA
   */
  exports.prototype['IsCA'] = undefined
  /**
   * @member {module:model/Name} Issuer
   */
  exports.prototype['Issuer'] = undefined
  /**
   * @member {Array.<String>} IssuingCertificateURL
   */
  exports.prototype['IssuingCertificateURL'] = undefined
  /**
   * @member {module:model/KeyUsage} KeyUsage
   */
  exports.prototype['KeyUsage'] = undefined
  /**
   * MaxPathLen and MaxPathLenZero indicate the presence and value of the BasicConstraints' \"pathLenConstraint\".  When parsing a certificate, a positive non-zero MaxPathLen means that the field was specified, -1 means it was unset, and MaxPathLenZero being true mean that the field was explicitly set to zero. The case of MaxPathLen==0 with MaxPathLenZero==false should be treated equivalent to -1 (unset).  When generating a certificate, an unset pathLenConstraint can be requested with either MaxPathLen == -1 or using the zero value for both MaxPathLen and MaxPathLenZero.
   * @member {Number} MaxPathLen
   */
  exports.prototype['MaxPathLen'] = undefined
  /**
   * MaxPathLenZero indicates that BasicConstraintsValid==true and MaxPathLen==0 should be interpreted as an actual maximum path length of zero. Otherwise, that combination is interpreted as MaxPathLen not being set.
   * @member {Boolean} MaxPathLenZero
   */
  exports.prototype['MaxPathLenZero'] = undefined
  /**
   * @member {Date} NotBefore
   */
  exports.prototype['NotBefore'] = undefined
  /**
   * RFC 5280, 4.2.2.1 (Authority Information Access)
   * @member {Array.<String>} OCSPServer
   */
  exports.prototype['OCSPServer'] = undefined
  /**
   * @member {Array.<String>} PermittedDNSDomains
   */
  exports.prototype['PermittedDNSDomains'] = undefined
  /**
   * Name constraints
   * @member {Boolean} PermittedDNSDomainsCritical
   */
  exports.prototype['PermittedDNSDomainsCritical'] = undefined
  /**
   * @member {Array.<String>} PermittedEmailAddresses
   */
  exports.prototype['PermittedEmailAddresses'] = undefined
  /**
   * @member {Array.<module:model/IPNet>} PermittedIPRanges
   */
  exports.prototype['PermittedIPRanges'] = undefined
  /**
   * @member {Array.<String>} PermittedURIDomains
   */
  exports.prototype['PermittedURIDomains'] = undefined
  /**
   * @member {Array.<module:model/ObjectIdentifier>} PolicyIdentifiers
   */
  exports.prototype['PolicyIdentifiers'] = undefined
  /**
   * @member {Object} PublicKey
   */
  exports.prototype['PublicKey'] = undefined
  /**
   * @member {module:model/PublicKeyAlgorithm} PublicKeyAlgorithm
   */
  exports.prototype['PublicKeyAlgorithm'] = undefined
  /**
   * @member {Array.<Number>} Raw
   */
  exports.prototype['Raw'] = undefined
  /**
   * @member {Array.<Number>} RawIssuer
   */
  exports.prototype['RawIssuer'] = undefined
  /**
   * @member {Array.<Number>} RawSubject
   */
  exports.prototype['RawSubject'] = undefined
  /**
   * @member {Array.<Number>} RawSubjectPublicKeyInfo
   */
  exports.prototype['RawSubjectPublicKeyInfo'] = undefined
  /**
   * @member {Array.<Number>} RawTBSCertificate
   */
  exports.prototype['RawTBSCertificate'] = undefined
  /**
   * @member {module:model/ModelInt} SerialNumber
   */
  exports.prototype['SerialNumber'] = undefined
  /**
   * @member {Array.<Number>} Signature
   */
  exports.prototype['Signature'] = undefined
  /**
   * @member {module:model/SignatureAlgorithm} SignatureAlgorithm
   */
  exports.prototype['SignatureAlgorithm'] = undefined
  /**
   * @member {module:model/Name} Subject
   */
  exports.prototype['Subject'] = undefined
  /**
   * @member {Array.<Number>} SubjectKeyId
   */
  exports.prototype['SubjectKeyId'] = undefined
  /**
   * @member {Array.<module:model/URL>} URIs
   */
  exports.prototype['URIs'] = undefined
  /**
   * UnhandledCriticalExtensions contains a list of extension IDs that were not (fully) processed when parsing. Verify will fail if this slice is non-empty, unless verification is delegated to an OS library which understands all the critical extensions.  Users can access these extensions using Extensions and can remove elements from this slice if they believe that they have been handled.
   * @member {Array.<module:model/ObjectIdentifier>} UnhandledCriticalExtensions
   */
  exports.prototype['UnhandledCriticalExtensions'] = undefined
  /**
   * @member {Array.<module:model/ObjectIdentifier>} UnknownExtKeyUsage
   */
  exports.prototype['UnknownExtKeyUsage'] = undefined
  /**
   * @member {Number} Version
   */
  exports.prototype['Version'] = undefined

  return exports
})
