/**
 * ORY Hydra - Cloud Native OAuth 2.0 and OpenID Connect Server
 * Welcome to the ORY Hydra HTTP API documentation. You will find documentation for all HTTP APIs here. Keep in mind that this document reflects the latest branch, always. Support for versioned documentation is coming in the future.
 *
 * OpenAPI spec version: Latest
 * Contact: hi@ory.am
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

;(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AttributeTypeAndValue'], factory)
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(
      require('../ApiClient'),
      require('./AttributeTypeAndValue')
    )
  } else {
    // Browser globals (root is window)
    if (!root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer) {
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer = {}
    }
    root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.Name = factory(
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.ApiClient,
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer
        .AttributeTypeAndValue
    )
  }
})(this, function(ApiClient, AttributeTypeAndValue) {
  'use strict'

  /**
   * The Name model module.
   * @module model/Name
   * @version Latest
   */

  /**
   * Constructs a new <code>Name</code>.
   * Name represents an X.509 distinguished name. This only includes the common elements of a DN. When parsing, all elements are stored in Names and non-standard elements can be extracted from there. When marshaling, elements in ExtraNames are appended and override other values with the same OID.
   * @alias module:model/Name
   * @class
   */
  var exports = function() {
    var _this = this
  }

  /**
   * Constructs a <code>Name</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Name} obj Optional instance to populate.
   * @return {module:model/Name} The populated <code>Name</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports()

      if (data.hasOwnProperty('Country')) {
        obj['Country'] = ApiClient.convertToType(data['Country'], ['String'])
      }
      if (data.hasOwnProperty('ExtraNames')) {
        obj['ExtraNames'] = ApiClient.convertToType(data['ExtraNames'], [
          AttributeTypeAndValue
        ])
      }
      if (data.hasOwnProperty('Locality')) {
        obj['Locality'] = ApiClient.convertToType(data['Locality'], ['String'])
      }
      if (data.hasOwnProperty('Names')) {
        obj['Names'] = ApiClient.convertToType(data['Names'], [
          AttributeTypeAndValue
        ])
      }
      if (data.hasOwnProperty('SerialNumber')) {
        obj['SerialNumber'] = ApiClient.convertToType(
          data['SerialNumber'],
          'String'
        )
      }
      if (data.hasOwnProperty('StreetAddress')) {
        obj['StreetAddress'] = ApiClient.convertToType(data['StreetAddress'], [
          'String'
        ])
      }
    }
    return obj
  }

  /**
   * @member {Array.<String>} Country
   */
  exports.prototype['Country'] = undefined
  /**
   * @member {Array.<module:model/AttributeTypeAndValue>} ExtraNames
   */
  exports.prototype['ExtraNames'] = undefined
  /**
   * @member {Array.<String>} Locality
   */
  exports.prototype['Locality'] = undefined
  /**
   * @member {Array.<module:model/AttributeTypeAndValue>} Names
   */
  exports.prototype['Names'] = undefined
  /**
   * @member {String} SerialNumber
   */
  exports.prototype['SerialNumber'] = undefined
  /**
   * @member {Array.<String>} StreetAddress
   */
  exports.prototype['StreetAddress'] = undefined

  return exports
})
